fl

{
LED driver (PCA9955A)
      
PropForth 5.5
2015/04/23 14:29:58

  There are 125 possible address lave-address of the device based on allcombination of 5 states connected to [AD0 AD1 AD2]
  5 states 
          1.tie to GND
          2.resister pull-down to ground
          3.open(floating)
          4.resistor pull-up to Vdd
          5.tie to Vdd]
  
  PCA9955A         
    REXT --- 10kohm ---GND
    AD0  ---  Floating
    AD1  ---  100kohm --- GND
    AD2  ---  GND
     OE  ---  GND
   RESET --- 10kohm --- 3.3V
   
     LED0 -- -LED+ -- 3.3V
     LED1 -- -LED+ -- 3.3V
     LED2 -- -LED+ -- 3.3V
     LED3 -- -LED+ -- 3.3V
     LED4 -- -LED+ -- 3.3V
     LED5 -- -LED+ -- 3.3V
     LED6 -- -LED+ -- 3.3V
     LED7 -- -LED+ -- 3.3V
     LED8 -- -LED+ -- 3.3V
     LED9 -- -LED+ -- 3.3V
    LED10 -- -LED+ -- 3.3V
    LED11 -- -LED+ -- 3.3V
    LED12 -- -LED+ -- 3.3V
    LED13 -- -LED+ -- 3.3V
    LED14 -- -LED+ -- 3.3V
    LED15 -- -LED+ -- 3.3V
}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres 8 for PCA9955A  
h10 wconstant PCA9955A 
\ All LED Call Address h70
hE0 wconstant PCA9955_call
\ GeneralCallAddress
0 wconstant GenCallAd

\ register
0 wconstant mode1
1 wconstant mode2
2 wconstant LEDOUT0
3 wconstant LEDOUT1
4 wconstant LEDOUT2
5 wconstant LEDOUT3
6 wconstant GRPPWM
7 wconstant GRPFREQ
8 wconstant PWM0
9 wconstant PWM1
hA wconstant PWM2
hB wconstant PWM3
hC wconstant PWM4
hD wconstant PWM5
hE wconstant PWM6
hF wconstant PWM7
h10 wconstant PWM8
h11 wconstant PWM9
h12 wconstant PWM10
h13 wconstant PWM11
h14 wconstant PWM12
h15 wconstant PWM13
h16 wconstant PWM14
h17 wconstant PWM15
h18 wconstant IREF0
h19 wconstant IREF1
h1A wconstant IREF2
h1B wconstant IREF3
h1C wconstant IREF4
h1D wconstant IREF5
h1E wconstant IREF6
h1F wconstant IREF7
h20 wconstant IREF8
h21 wconstant IREF9
h22 wconstant IREF10
h23 wconstant IREF11
h24 wconstant IREF12
h25 wconstant IREF13
h26 wconstant IREF14
h27 wconstant IREF15
h28 wconstant RAMP_RATE_GRP0
h29 wconstant STEP_TIME_GRP0
h2A wconstant HOLD_CNTL_GRP0
h2B wconstant IREF_GRP0
h2C wconstant RAMP_RATE_GRP1
h2D wconstant STEP_TIME_GRP1
h2E wconstant HOLD_CNTL_GRP1
h2F wconstant IREF_GRP1
h30 wconstant RAMP_RATE_GRP2
h31 wconstant STEP_TIME_GRP2
h32 wconstant HOLD_CNTL_GRP2
h33 wconstant IREF_GRP2
h34 wconstant RAMP_RATE_GRP3
h35 wconstant STEP_TIME_GRP3
h36 wconstant HOLD_CNTL_GRP3
h37 wconstant IREF_GRP3
h38 wconstant GRAD_MODE_SEL0
h39 wconstant GRAD_MODE_SEL1
h3A wconstant GRAD_GRP_SEL0
h3B wconstant GRAD_GRP_SEL1
h3C wconstant GRAD_GRP_SEL2
h3D wconstant GRAD_GRP_SEL3
h3E wconstant GRAD_CNTL
h3F wconstant OFFSET
h40 wconstant SUBADR1
h41 wconstant SUBADR2
h42 wconstant SUBADR3
h43 wconstant ALLCALLADR
h44 wconstant PWMALL
h45 wconstant IREFALL
h46 wconstant EFLAG0
h47 wconstant EFLAG1
h48 wconstant EFLAG2
h49 wconstant EFLAG3

\ Auto Increment Code
0 wconstant no_inc
h80 wconstant all_inc          \ (register:0 - h11)
hA0 wconstant bright_inc       \ (register:2 - h11)
hC0 wconstant group_inc        \ (register:hA - hB)
hE0 wconstant brt_grp_inc      \ (register:2 - hB)
 
\ =========================================================================== 
\ Main 
\ =========================================================================== 

\ Software Reset
\ After send 6 following GenCallAd, PCA9955 is resetting.
\ ( -- )
: SoftReset
\ Start I2C 
_eestart
\ Write SWRST, then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
GenCallAd _eewrite                      
6 _eewrite or
\ Stop I2C
_eestop
err? 
;

\ TAB
\ ( -- )
: tab 9 emit ;
: 2tab tab tab ;

\ Set auto increment
\ ( -- )
: AutoIncr h80 or ;

\ Display all registers from mode1 to ALLCALLADR
\ ( -- )
: rd_allreg
." register number[hex]:value[hex]"  cr cr
hex
d10 0 do
     8 0 do
          j 8 * i + d74 <
          if
               mode1 AutoIncr j 8 * i + + PCA9955A i2c_rd err?
               j 8 * i + .byte ." :" 
               .byte 2 spaces
          else
               8 seti
          then
     loop 
     cr  
loop
decimal
cr
;

\ Write data to register
\ ( n1 n2 -- )  n1:data[1byte] n2:register number
: data_wr PCA9955A i2c_wr err? ;


\ Drive 16 LED elemets from pwm 0% to pwm 99.6%
\ ( -- )
: demo
\ Set Normal[b4]
9 mode1 PCA9955A i2c_wr err?   
\ Set LED15-0 to PWM 
\ LDRx=10
hAA hAA hAA hAA 4 LEDOUT0 AutoIncr PCA9955A i2c_wr_multi err?  
\ Set IREF15-0 to  h80
h80 h80 h80 h80 h80 h80 h80 h80 8 IREF0 AutoIncr PCA9955A i2c_wr_multi err? 
                                                                          
begin
     d256 0 do
          i i i i i i i i i i i i i i i i 
          d16 PWM0 AutoIncr PCA9955A i2c_wr_multi err? 
          d10 delms                                         
     loop                    
     fkey? swap drop         
until                     
SoftReset                        
;
